# TODO:
# - check file permissions
# - check files in /usr/share/rt3/
# - check Requires (meta-packages for configurations with mod_perl/fcgi,
#   apache[12]/standalone server...?)
# - separate standalone server
#
%define	perl_ver				5.8.3
%define	perl_apache_session_ver			1.53
%define	perl_cgi_ver				3.38
%define	perl_class_returnvalue_ver		0.40
%define	perl_css_squish_ver			0.06
%define	perl_dbd_mysql				2.1018
%define	perl_dbi_ver				1.37
%define	perl_dbix_searchbuilder_ver		1.59
%define	perl_devel_stacktrace_ver		1.19
%define	perl_digest_md5_ver			2.27
%define	perl_html_mason_ver			3:1.43
%define	perl_html_rewriteattributes_ver		0.05
%define	perl_html_scrubber_ver			0.08
%define	perl_http_server_simple_mason_ver	0.09
%define	perl_http_server_simple_ver		0.34
%define	perl_locale_maketext_lexicon_ver	0.32
%define	perl_locale_maketext_ver		1.06
%define	perl_log_dispatch_ver			2.0
%define	perl_mailtools_ver			1.57
%define	perl_mime_tools_ver			5.425
%define	perl_module_versions_report_ver		1.05
%define	perl_cgi_psgi				0.12
%define	perl_storable_ver			2.08
%define	perl_text_quoted_ver			2.02
%define	perl_text_wikiformat_ver		0.76
%define	perl_tree_simple_ver			1.18
%define	perl_text_template_ver			1.45
%define	perl_xml_rss_ver			1.05
#
%bcond_with	testdeps	# used for checking dependencies
%bcond_without	apache		# no apache deps. TODO: make subpackage with apache config
#
%include	/usr/lib/rpm/macros.perl
Summary:	Request Tracker
Summary(pl.UTF-8):	Request Tracker - system do śledzenia zleceń
Name:		rt
Version:	4.0.17
Release:	1
License:	GPL v2
Group:		Applications
Source0:	http://download.bestpractical.com/pub/rt/release/%{name}-%{version}.tar.gz
# Source0-md5:	aad39ab243853f991d8f78e85c1181f8
Source1:	%{name}-apache_dir.conf
Source2:	%{name}-apache_vhost.conf
Source3:	%{name}-apache.conf
Source4:	%{name}.logrotate
Patch0:		%{name}-layout.patch
Patch1:		%{name}-config.patch
URL:		http://www.bestpractical.com/rt/
BuildRequires:	autoconf
BuildRequires:	automake
%if %{with testdeps}
BuildRequires:	perl-Apache-DBI
BuildRequires:	perl-Apache-Session >= %{perl_apache_session_ver}
BuildRequires:	perl-CGI >= %{perl_cgi_ver}
BuildRequires:	perl-CGI-Emulate-PSGI
BuildRequires:	perl-CGI-PSGI >= %{perl_cgi_psgi}
BuildRequires:	perl-CGI-SpeedyCGI
BuildRequires:	perl-CSS-Squish >= %{perl_css_squish_ver}
BuildRequires:	perl-Cache-Cache
BuildRequires:	perl-Calendar-Simple
BuildRequires:	perl-Class-ISA
BuildRequires:	perl-Class-ReturnValue >= %{perl_class_returnvalue_ver}
BuildRequires:	perl-Convert-Color
BuildRequires:	perl-DBD-mysql >= %{perl_dbd_mysql}
BuildRequires:	perl-DBI >= %{perl_dbi_ver}
BuildRequires:	perl-DBIx-DataSource >= 0.02
BuildRequires:	perl-DBIx-SearchBuilder >= %{perl_dbix_searchbuilder_ver}
BuildRequires:	perl-Data-ICal
BuildRequires:	perl-Devel-GlobalDestruction
BuildRequires:	perl-Devel-StackTrace >= %{perl_devel_stacktrace_ver}
BuildRequires:	perl-Digest-MD5 >= %{perl_digest_md5_ver}
BuildRequires:	perl-Email-Address
BuildRequires:	perl-Exception-Class
BuildRequires:	perl-FCGI
BuildRequires:	perl-FCGI-ProcManager
BuildRequires:	perl-File-ShareDir
BuildRequires:	perl-File-Temp
BuildRequires:	perl-FreezeThaw
BuildRequires:	perl-GD
BuildRequires:	perl-GD-Graph
BuildRequires:	perl-GD-TextUtil
BuildRequires:	perl-GnuPG-Interface
BuildRequires:	perl-HTML-Mason >= %{perl_html_mason_ver}
BuildRequires:	perl-HTML-Mason-PSGIHandler
BuildRequires:	perl-HTML-Parser
BuildRequires:	perl-HTML-Quoted
BuildRequires:	perl-HTML-RewriteAttributes >= %{perl_html_rewriteattributes_ver}
BuildRequires:	perl-HTML-Scrubber >= %{perl_html_scrubber_ver}
BuildRequires:	perl-HTML-Tree
BuildRequires:	perl-HTTP-Server-Simple >= %{perl_http_server_simple_ver}
BuildRequires:	perl-HTTP-Server-Simple-Mason >= %{perl_http_server_simple_mason_ver}
BuildRequires:	perl-IPC-Run3
BuildRequires:	perl-JSON
BuildRequires:	perl-JavaScript-Minifier
BuildRequires:	perl-Locale-Maketext >= %{perl_locale_maketext_ver}
BuildRequires:	perl-Locale-Maketext-Fuzzy
BuildRequires:	perl-Locale-Maketext-Lexicon >= %{perl_locale_maketext_lexicon_ver}
BuildRequires:	perl-Log-Dispatch >= %{perl_log_dispatch_ver}
BuildRequires:	perl-MIME-Types
BuildRequires:	perl-MIME-tools >= %{perl_mime_tools_ver}
BuildRequires:	perl-MLDBM
BuildRequires:	perl-MailTools >= %{perl_mailtools_ver}
BuildRequires:	perl-Module-Versions-Report >= %{perl_module_versions_report_ver}
BuildRequires:	perl-Net-CIDR
BuildRequires:	perl-Net-Server >= 0.34
BuildRequires:	perl-PSGI
BuildRequires:	perl-Params-Validate >= 0.02
BuildRequires:	perl-PerlIO-eol
BuildRequires:	perl-Plack
BuildRequires:	perl-Regexp-Common
BuildRequires:	perl-Regexp-Common-net-CIDR
BuildRequires:	perl-Regexp-IPv6
BuildRequires:	perl-Starlet
BuildRequires:	perl-Storable >= %{perl_storable_ver}
BuildRequires:	perl-Term-ReadKey
BuildRequires:	perl-Test-Inline
BuildRequires:	perl-Text-Autoformat
BuildRequires:	perl-Text-Password-Pronounceable
BuildRequires:	perl-Text-Quoted >= %{perl_text_quoted_ver}
BuildRequires:	perl-Text-Template >= %{perl_text_template_ver}
BuildRequires:	perl-Text-WikiFormat >= %{perl_text_wikiformat_ver}
BuildRequires:	perl-Text-Wrapper
BuildRequires:	perl-Tie-IxHash
BuildRequires:	perl-Time-HiRes
BuildRequires:	perl-Time-modules
BuildRequires:	perl-TimeDate
BuildRequires:	perl-Tree-Simple >= %{perl_tree_simple_ver}
BuildRequires:	perl-UNIVERSAL-require
BuildRequires:	perl-WWW-Mechanize
BuildRequires:	perl-XML-RSS >= %{perl_xml_rss_ver}
BuildRequires:	perl-libnet
%endif
BuildRequires:	perl-base >= %{perl_ver}
BuildRequires:	rpm-perlprov
%if %{with apache}
Requires:	apache-base >= 2.2.0
Requires:	apache-mod_authz_host >= 2.2.0
Requires:	apache-mod_perl >= 2.0
%endif
Requires:	fonts-TTF-Google-Droid
Requires:	perl-Apache-DBI
Requires:	perl-Apache-Session >= %{perl_apache_session_ver}
Requires:	perl-CGI >= %{perl_cgi_ver}
Requires:	perl-CGI-Emulate-PSGI
Requires:	perl-CGI-PSGI >= %{perl_cgi_psgi}
Requires:	perl-CSS-Squish >= %{perl_css_squish_ver}
Requires:	perl-Cache-Cache
Requires:	perl-Calendar-Simple
Requires:	perl-Class-ISA
Requires:	perl-Class-ReturnValue >= %{perl_class_returnvalue_ver}
Requires:	perl-Convert-Color
Requires:	perl-DBD-mysql >= %{perl_dbd_mysql}
Requires:	perl-DBI >= %{perl_dbi_ver}
Requires:	perl-DBIx-SearchBuilder >= %{perl_dbix_searchbuilder_ver}
Requires:	perl-Data-ICal
Requires:	perl-Devel-GlobalDestruction
Requires:	perl-Devel-StackTrace >= %{perl_devel_stacktrace_ver}
Requires:	perl-Digest-MD5 >= %{perl_digest_md5_ver}
Requires:	perl-Encode >= 2.38
Requires:	perl-FCGI-ProcManager
Requires:	perl-GD-Graph
Requires:	perl-GnuPG-Interface
Requires:	perl-HTML-Mason >= %{perl_html_mason_ver}
Requires:	perl-HTML-Mason-PSGIHandler
Requires:	perl-HTML-Quoted
Requires:	perl-HTML-RewriteAttributes >= %{perl_html_rewriteattributes_ver}
Requires:	perl-HTML-Scrubber >= %{perl_html_scrubber_ver}
Requires:	perl-HTTP-Server-Simple >= %{perl_http_server_simple_ver}
Requires:	perl-HTTP-Server-Simple-Mason >= %{perl_http_server_simple_mason_ver}
Requires:	perl-IPC-Run3
Requires:	perl-JSON
Requires:	perl-JavaScript-Minifier
Requires:	perl-Locale-Maketext >= %{perl_locale_maketext_ver}
Requires:	perl-Locale-Maketext-Fuzzy
Requires:	perl-Locale-Maketext-Lexicon >= %{perl_locale_maketext_lexicon_ver}
Requires:	perl-Log-Dispatch >= %{perl_log_dispatch_ver}
Requires:	perl-MIME-tools >= %{perl_mime_tools_ver}
Requires:	perl-MailTools >= %{perl_mailtools_ver}
Requires:	perl-Module-Versions-Report >= %{perl_module_versions_report_ver}
Requires:	perl-Moose
Requires:	perl-Net-CIDR
Requires:	perl-PSGI
Requires:	perl-PerlIO-eol
Requires:	perl-Plack
Requires:	perl-Regexp-Common-net-CIDR
Requires:	perl-Regexp-IPv6
Requires:	perl-Starlet
Requires:	perl-Storable >= %{perl_storable_ver}
Requires:	perl-Text-Password-Pronounceable
Requires:	perl-Text-Quoted >= %{perl_text_quoted_ver}
Requires:	perl-Text-WikiFormat >= %{perl_text_wikiformat_ver}
Requires:	perl-Tree-Simple >= %{perl_tree_simple_ver}
Requires:	perl-XML-RSS >= %{perl_xml_rss_ver}
Requires:	perl-base >= %{perl_ver}
Requires:	webapps
Suggests:	perl-FCGI
Conflicts:	apache-base < 2.4.0-1
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreq	'perl().*' 'perl(RT.*)' 'perl(Encode::compat)' 'perl(CGI::Fast)' 'perl(Exception::Class::Base)' 'perl(HTML::Mason::Request::PSGI)'
# workarounds for bug in perl.req ("perl()") and ,,famous'' rpm's feature (RT::*)

%define         _webapps        /etc/webapps
%define         _webapp         %{name}
%define         _webappsdir     %{_webapps}/%{_webapp}
%define		_sysconfdir	/etc/rt3
%define		_libdir		%{perl_vendorlib}
%define		htmldir		%{_datadir}/rt3/html
%define		masonstatedir	%{_localstatedir}/cache/mason_data
%define		masonsessiondir	%{_localstatedir}/cache/session_data

%description
RT is an enterprise-grade ticketing system which enables a group of
people to intelligently and efficiently manage tasks, issues, and
requests submitted by a community of users.

%description -l pl.UTF-8
RT to profesjonalnej klasy system biletowy pozwalający grupie ludzi
inteligentnie i wydajnie zarządzać zadaniami, problemami i zleceniami
składanymi przez użytkowników.

%package cli
Summary:	Command-line interface to RT
Summary(pl.UTF-8):	Interfejs linii poleceń dla RT
Group:		Applications

%description cli
This package contains /usr/bin/rt, a command-line interface to RT 3.

It allows you to interact with an RT server over HTTP, and offers an
interface to RT's functionality that is better-suited to automation
and integration with other tools.

%description cli -l pl.UTF-8
Ten pakiet zawiera /usr/bin/rt - interfejs linii poleceń do RT 3.

Umożliwia on współdziałanie z serwerem RT po HTTP i oferuje interfejs
do funkcjonalności RT bardziej dopasowany do automatyki i intergracji
z innymi narzędziami.

%prep
%setup -q
%patch0 -p0
%patch1 -p1

mv aclocal.m4 acinclude.m4

sed -i -e 's#libdir:.*#libdir:	%{_libdir}#g' config.layout

%build
%{__aclocal}
%{__autoconf}
USER=$(id -un) \
%configure \
	--enable-layout=PLDFHS \
	htmldir=%{htmldir} \
	exp_htmldir=%{htmldir} \
	masonstatedir=%{masonstatedir} \
	masonsessiondir=%{masonstatedir} \
	--with-apachectl=%{_sbindir}/apachectl \
	--with-my-user-group \
	--with-db-type=mysql \
	--with-web-handler=fastcgi,modperl2

%{?with_testdeps:%{__make} testdeps}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{logrotate.d,cron.daily},%{_libdir}} \
	$RPM_BUILD_ROOT%{masonstatedir} \
	$RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version} \
	$RPM_BUILD_ROOT%{_webappsdir}

# this is make install minus fixperms
%{__make} config-install dirs files-install instruct \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} %{SOURCE2} $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
install %{SOURCE3} $RPM_BUILD_ROOT%{_webappsdir}/httpd.conf
install %{SOURCE4} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}

ln -s %{_sbindir}/rt-clean-sessions $RPM_BUILD_ROOT/etc/cron.daily/rt-clean-sessions

# unneeded in installed copy
rm $RPM_BUILD_ROOT%{_sbindir}/rt-test-dependencies

# we use fonts-TTF-Google-Droid
rm -r $RPM_BUILD_ROOT%{_datadir}/fonts/TTF

# *.in, tests
find $RPM_BUILD_ROOT -type f -name \*.in -exec rm '{}' \;

%triggerin -- apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache-base
%webapp_unregister httpd %{_webapp}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README* docs etc/upgrade

%dir %{_sysconfdir}
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/[a-z]*
# this is local config
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/RT_SiteConfig.pm
# this is generic config that SHOULDN'T BE TOUCHED. Change settings in your local (site) config.
%attr(640,root,http) %config %{_sysconfdir}/RT_Config.pm

%if %{with apache}
%dir %attr(750,root,http) %{_webappsdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_webappsdir}/httpd.conf
%endif
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/%{name}
%attr(755,root,root) /etc/cron.daily/rt-clean-sessions
%attr(755,root,root) %{_bindir}/rt-*
%attr(755,root,root) %{_sbindir}/standalone_httpd
%attr(755,root,root) %{_sbindir}/rt-*
%dir %{_datadir}/rt
%{_datadir}/rt/html
%{_datadir}/rt/po
%{_libdir}/*
%dir %attr(770,root,http) %{masonstatedir}
%{_examplesdir}/%{name}-%{version}

%files cli
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/rt
%changelog
* Fri Aug 09 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/rt.git;a=log;h=master

* Fri Aug 09 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> e97d451
- up to 4.0.17

* Mon Jul 29 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> e24bb8b
- up to 4.0.16

* Fri Jul 26 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 9222a5a
- up to 4.0.15

* Sat Jun 22 2013 Jan Rękorajski <baggins@pld-linux.org> 22d5ae5
- remove BR/R of non exsitant package, provided by perl-base
- rel 2

* Wed May 22 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> c79eb49
- up to 4.0.13; tons of SECURITY fixes: CVE-2012-4733, CVE-2013-3368, CVE-2013-3369, CVE-2013-3370, CVE-2013-3371, CVE-2013-3372, CVE-2013-3373, CVE-2013-3374

* Wed May 22 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 5c7e2b4
- no apache bcond

* Fri May 17 2013 Jan Rękorajski <baggins@pld-linux.org> d6f85e2
- migrated to apache 2.4

* Mon May 13 2013 Adam Gołębiowski <adamg@pld-linux.org> 1fad8a8
- updated to 4.0.12

* Thu Apr 18 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> c70c6c5
- up to 4.0.11

* Wed Jan 30 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> d440110
- up to 4.0.10

* Mon Jan 21 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 2e16610
- up to 4.0.9

* Fri Oct 26 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> bceecd0
- up to 4.0.8; fixes CVE-2012-4730, CVE-2012-4731, CVE-2012-4732, CVE-2012-4734, CVE-2012-4735 and CVE-2012-4884

* Mon Aug 27 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 980a7a7
- up to 4.0.7

* Tue Jul 17 2012 Jan Rękorajski <baggins@pld-linux.org> b9c44da
- perl(HTML::Mason::Request::PSGI) is provided indirectly by HTML-Mason-PSGIHandler
Release 2

* Mon Jul 02 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> dd68e5a
- add logrotate config

* Tue May 22 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 85f2c40
- up to 4.0.6 (fixes CVE-2011-2082,
CVE-2011-2083, CVE-2011-2084, CVE-2011-2085, CVE-2011-4458,
CVE-2011-4459, and CVE-2011-4460)

* Fri Feb 03 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 38f3925
- up to 4.0.5

* Mon Nov 28 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> d11bb32
- add R: perl-Cache-Cache

* Fri Nov 11 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 4f0eeac
- up to 4.0.4

* Thu Nov 03 2011 Sławomir Paszkiewicz <paszczus@pld-linux.org> 567eb33
- release 2

